org.eclipse.cdt.core.dom.ast

## Interface IASTEnumerationSpecifier

All Superinterfaces:
  IASTDeclSpecifier, IASTNameOwner, IASTNode

All Known Subinterfaces:
  ICASTEnumerationSpecifier, ICPPASTEnumerationSpecifier

    public interface IASTEnumerationSpecifier
    extends IASTDeclSpecifier, IASTNameOwner

This interface represents enumerations in C and C++.

### Nested Class Summary

Nested Classes
`static interface` `IASTEnumerationSpecifier.IASTEnumerator` This interface represents an enumerator member of an enum specifier.

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

### Field Summary

Fields
`static ASTNodeProperty` `ENUMERATION_NAME` `ENUMERATION_NAME` describes the relationship between `IASTEnumerationSpecifier` and its `IASTName`.
`static ASTNodeProperty` `ENUMERATOR` `ENUMERATOR` describes the relationship between `IASTEnumerationSpecifier` and the nested `IASTEnumerationSpecifier.IASTEnumerator`s.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclSpecifier

`ALIGNMENT_SPECIFIER, sc_auto, sc_extern, sc_mutable, sc_register, sc_static, sc_typedef, sc_unspecified`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNameOwner

`r_declaration, r_definition, r_reference, r_unclear`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addEnumerator(IASTEnumerationSpecifier.IASTEnumerator enumerator)` Adds an enumerator.
`IASTEnumerationSpecifier` `copy()` Returns a mutable copy of the tree rooted at this node.
`IASTEnumerationSpecifier` `copy(IASTNode.CopyStyle style)` Returns a mutable copy of the tree rooted at this node.
`IASTEnumerationSpecifier.IASTEnumerator[]` `getEnumerators()` Returns enumerators.
`IASTName` `getName()` Returns the enum's name.
`void` `setName(IASTName name)` Sets the enum's name.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclSpecifier

`getAlignmentSpecifiers, getStorageClass, isConst, isInline, isRestrict, isVolatile, setAlignmentSpecifiers, setConst, setInline, setRestrict, setStorageClass, setVolatile`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNameOwner

`getRoleForName`

### Field Detail

#### ENUMERATION_NAME

    static final ASTNodeProperty ENUMERATION_NAME

`ENUMERATION_NAME` describes the relationship between `IASTEnumerationSpecifier` and its `IASTName`.

#### ENUMERATOR

    static final ASTNodeProperty ENUMERATOR

`ENUMERATOR` describes the relationship between `IASTEnumerationSpecifier` and the nested `IASTEnumerationSpecifier.IASTEnumerator`s.

### Method Detail

#### addEnumerator

    void addEnumerator(IASTEnumerationSpecifier.IASTEnumerator enumerator)

Adds an enumerator.

Parameters:
  `enumerator` - `IASTEnumerator`

#### getEnumerators

    IASTEnumerationSpecifier.IASTEnumerator[] getEnumerators()

Returns enumerators.

Returns:
  `IASTEnumerator[]` array

#### setName

    void setName(IASTName name)

Sets the enum's name.

Parameters:
  `name` -

#### getName

    IASTName getName()

Returns the enum's name.

#### copy

    IASTEnumerationSpecifier copy()

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTDeclSpecifier`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

#### copy

    IASTEnumerationSpecifier copy(IASTNode.CopyStyle style)

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTDeclSpecifier`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3